import { ConfigSource as BaseConfigSource } from '@erect/config';
export { BaseConfigSource };
export interface CortexQLConfigSource {
    /**
     * The address the server will listen
     */
    listenAddress: string;
    /**
     * The port the server will listen
     */
    listenPort: number;
    /**
     * The host accessable through the browser
     */
    host: string;
    /**
     * Disable subscription websocket (Subscription wont show)
     */
    disableSubscription: boolean;
}
export interface ConfigSource extends BaseConfigSource, CortexQLConfigSource {
}
export declare const extendConfig: <T extends ConfigSource>() => {
    config: ((path: string | number | symbol | PropertyKey[], defaultValue?: any) => any) & T;
    loadConfig: (values: T) => void;
};
export declare const config: ((path: string | number | symbol | PropertyKey[], defaultValue?: any) => any) & ConfigSource, loadConfig: (values: ConfigSource) => void;
export default config;
