"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * This script builds a production output of all of our bundles.
 */
const path_1 = require("path");
const appRootDir = require("app-root-dir");
const build_yargs_1 = require("./build.yargs");
const exec_1 = require("../utils/exec");
const getTranspiler_1 = require("../../api/getTranspiler");
const paths_1 = require("../../paths");
const fs = require("fs-extra");
require('ts-node/register');
require('tsconfig-paths/register');
exports.default = (argv) => __awaiter(this, void 0, void 0, function* () {
    // First clear the build output dir.
    exec_1.exec(`rimraf ${path_1.resolve(appRootDir.get(), 'build')}`);
    console.log('Building TypeScript...');
    exec_1.exec('tsc');
    console.log('Building GraphQL Schema...');
    const transpiler = getTranspiler_1.getTranspiler();
    transpiler.dumpSchema(paths_1.getBuildSchemaPath());
    fs.copySync(path_1.resolve(appRootDir.get(), './tsconfig.json'), path_1.resolve(paths_1.getBuildPath(), './tsconfig.json'));
});
if (!module.parent) {
    build_yargs_1.handler(build_yargs_1.builder().argv)
        .catch(err => {
        console.log(err.stack);
    });
}
//# sourceMappingURL=build.js.map