"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const start_yargs_1 = require("./start.yargs");
const build_1 = require("./build");
const paths_1 = require("../../paths");
const exec_1 = require("../utils/exec");
exports.default = (argv) => __awaiter(this, void 0, void 0, function* () {
    if (argv.rebuild || !fs.existsSync(paths_1.getBuildPath())) {
        yield build_1.default({ _: [], $0: '' });
    }
    exec_1.exec(`cross-env CORTEXQL_COMMAND=start node -r tsconfig-paths/register ${paths_1.getBuildRootPath()}`, {
        cwd: paths_1.getBuildPath(),
    });
});
if (!module.parent) {
    start_yargs_1.handler(start_yargs_1.builder().argv)
        .catch(err => {
        console.log(err.stack);
    });
}
//# sourceMappingURL=start.js.map